import 'package:flutter/material.dart';
import 'package:flutter_native_web/flutter_native_web.dart';


class PaymentPage extends StatelessWidget {

  PaymentPage({this.paymentData});

  dynamic paymentData;

  WebController webController;

  void onWebCreated(webController) {
    this.webController = webController;
    this.webController.loadUrl("${paymentData['authorization_url']}");
    this.webController.onPageStarted.listen((url) =>
      print("Loading $url")
    );
    this.webController.onPageFinished.listen((url) =>
      print("Finished loading $url")
    );
  }

  Future<bool> requestCancel(BuildContext context) async {
    var response = await showDialog(
      barrierDismissible: false,
      barrierColor: Colors.black26,
      barrierLabel: 'Hello this is a label',
      context: context, 
      builder: (context) {
        return AlertDialog(
          title: Text('Confirm'),
          content: Container(
            child: Text('Have you complete this payment?'),
          ),
          actions: [
            TextButton(
              onPressed: () {
                Navigator.of(context).pop(true);
              }, 
              child: Text('Yes')
            ),
            TextButton(
              onPressed: () {
                Navigator.of(context).pop(false);
              }, 
              child: Text('No')
            ),
          ],
        );
      },
    );
    print("Selected Option: $response");
    if (response != null) {
      response = response as bool;
      if (response) {
        Navigator.of(context).pop(paymentData);
      }
      return response;
    }
    return false;
  }

  

  @override
  Widget build(BuildContext context) {

    return WillPopScope(
      onWillPop: () => requestCancel(context),
      child: Scaffold(
        body: Stack(
          children: [
            Positioned(
              top: 0, left: 0, right: 0, bottom: 0,
              child: Container(
                margin: const EdgeInsets.only(top: 30),
                child: FlutterNativeWeb(
                  onWebCreated: onWebCreated,
                ),
              ),
            ),
            Positioned(
              bottom: 0, left: 0, right: 0,
              child: ButtonBar(
                alignment: MainAxisAlignment.center,
                children: [
                  ElevatedButton(
                    child: Text('Confirm Payment'),
                    onPressed: (){
                      Navigator.of(context).pop(paymentData);
                    },
                  ),
                  ElevatedButton(
                    child: Text('Cancel Payment'),
                    onPressed: (){
                      Navigator.of(context).pop(paymentData);
                    },
                    style: ButtonStyle(
                      backgroundColor: MaterialStateColor.resolveWith((states) {
                        return Colors.red;
                      })
                    ),
                  ),
                ],
              ),
            )
          ],
        ),
      ),
    );
  }
}