
import 'package:dio/dio.dart';
import 'package:paystack_plus/src/model/response.model.dart';
import 'package:pretty_dio_logger/pretty_dio_logger.dart';
// import 'package:pretty_dio_logger/pretty_dio_logger.dart';

class ApiHelper {

  static Future<ApiResponse> makeGetRequest({url, headers}) async {
    Dio dio = Dio();

    return dio.get(url, options: Options(
      headers: {
        ...headers,
        'Content-Type': 'application/json'
      }
    )).then((value) => ApiResponse.fromJson(value.data));
  }


  static Future<ApiResponse> makePostRequest({url, data, headers}) async {
    Dio dio = Dio();

    dio.interceptors.add(PrettyDioLogger());

    return dio.post(url, data: FormData.fromMap(data), options: Options(
      headers: {
        ...headers,
        'Content-Type': 'application/json'
      }
    )).then((value) => ApiResponse.fromJson(value.data));
  }
}